#include <avr/io.h>
//#include <avr/signal.h>
#include <avr/interrupt.h>
#include <stdint.h>


#define TAKT = 16000000UL;

unsigned long takt = 16000000ul;
unsigned long baud = 28800ul;
unsigned long baud2 = 57600ul;
unsigned long baud3 = 14400ul;

unsigned char Rowwadd;
unsigned char Colladd; 

unsigned int A_word; 
unsigned int B_word; 

unsigned char D_byte; 
unsigned char Col; 
unsigned char Page; 
unsigned char Pointer; 

unsigned char S_byte; 
unsigned char T_byte; 
unsigned char U_byte; 
unsigned char V_byte; 
unsigned char W_byte; 
unsigned char X_byte; 
unsigned char Y_byte; 
unsigned char Z_byte; 
unsigned char Tempbyte; 
volatile unsigned char Flag; 
unsigned char Cam_aktion; 
unsigned char Ack_counter; 

unsigned char Collhigh_w;
unsigned char Colllow_w; 
unsigned char Rowhigh_w; 
unsigned char Rowlow_w; 

unsigned char Transfer_byte[19];


void Spiout (unsigned char wert){
	SPDR=wert; 							// Wert in Ausganspuffer
	loop_until_bit_is_set(SPSR, SPIF); 	// warten bis Puffer lehr, erstes Bit gesendet
	wert=SPDR;  						// SPSR, SPIF-Bit wieder lschen durch pseudolesen
}

void us1 (void) {  						// Wartefunktion
	unsigned int i;						// Lokale Variable deklarieren
	for ( i = 0x00; 1<takt/6000000; i++){
	}		// warte ca. 1 ms
}

void ms1 (void) {  						// Wartefunktion
	unsigned int i;						// Lokale Variable deklarieren
	for (i = 0x00; 1<takt/6000; i++){	// warte ca. 1 ms
	}
}

void Waitus ( unsigned char wert){
	unsigned char i;
	for (i = 0x00; i < wert ; i++){
		us1();
	}
}

void Waitms ( unsigned char wert){
	unsigned char i;
	for (i = 0x00; i < wert ; i++){
		ms1();
	}
	
}

void Wait ( unsigned char wert){
	unsigned int x;
	unsigned int y;
	y = wert * 1000;
	for (x = 0x00; x < y ; x++){
		ms1();
	}
}

void Printbin ( unsigned char wert){
	loop_until_bit_is_set(UCSRA, UDRE);
	UDR = wert;
}

void Cam_config (void) {
//  init Cam
		Flag = 0;
		while (Flag == 0){
     	Printbin (0xAA);
     	Printbin (0x01);
     	Printbin (0x00);
     	Printbin (0x03);
     	Printbin (0x01);
     	Printbin (0x01);
     	Waitms (50);
		}
	while (Flag != 2) {
	}
		Flag = 0;
}

void Cam_packsize (void) {
// Packagesize fr Cam vorgeben
		Flag=0;
	while (Flag == 0){
     	Printbin (0xAA);
     	Printbin (0x06);
     	Printbin (0x08);
     	Printbin (0x42);
     	Printbin (0x00);
     	Printbin (0x00);
     	Waitms (3);
		}
	while (Flag != 2) {
	}
		Flag = 0;
}

void Cam_baudrate (void){
// Kamera neue Baudrate angeben
	Flag = 0;
		while (Flag == 0){
         Printbin (0xAA);
         Printbin (0x07);
         Printbin (0x3F);
         Printbin (0x01);
         Printbin (0x00);
         Printbin (0x00);
         Waitms (50);
   	}
	while (Flag != 2) {
	}
		Flag = 0;
}

void Cam_reset (void){
		Flag=0;
	while (Flag == 0){
     	Printbin (0xAA);
     	Printbin (0x08);
     	Printbin (0x01);
     	Printbin (0x00);
     	Printbin (0x00);
     	Printbin (0x00);
     	Waitms (10);
		}
		while (Flag != 2) {
	}
		Flag = 0;
}

void Cam_sync (void){
  //' sync
  	Flag = 0;
  	Transfer_byte[7] = 0;
  	while (Transfer_byte[2] != 0x0e){
  		while (Flag == 0){
      		Printbin (0xAA);
      		Printbin (0x0D);
      		Printbin (0x00);
      		Printbin (0x00);
      		Printbin (0x00);
      		Printbin (0x00);
      		Waitms (10);
  		}
  		while (Flag != 2){
  		}
	}
		Flag = 0;
		while (Flag != 2){
		}
		Flag = 0;
		Waitms (1);
		Printbin (0xAA);
		Printbin (0x0E);
		Printbin (0x00);
		Printbin (0x00);
		Printbin (0x00);
		Printbin (0x00);
		Waitms (10);
}

void Cam_ack (void){
		Ack_counter++;
		Printbin (0xAA);
		Printbin (0x0E);
		Printbin (0x0A);
		Printbin (Ack_counter);
		Printbin (0x00);
		Printbin (0x00);
}

void Glcd_clear (void) {
	X_byte = 0x00;
	for (Page = 0x00 ; Page == 0x07; Page++){
	    PORTB = PORTB & 0xfe; 			// Portb.0  A = 0; PortB0=0 
	    D_byte = 0xB0;
	    D_byte = D_byte | Page;         // start Dispay Page
	    Spiout(D_byte);
	    D_byte = 0x00; 					// auf Startposition zurck (CR)
	    Spiout(D_byte);
	    Waitus(5);  					// warte 5us
	    
	    Pointer = 0;

	    for (Pointer = 1; Pointer==125;Pointer++){
	       Spiout(X_byte);
	    }
	}
	PORTB &= ~((1 << PB0));  			//PORTB.0=0
	D_byte = 0xB1;
	Spiout(D_byte);
	D_byte = 0x00;  					// auf Startposition zurck (CR)
	Spiout(D_byte);
	
	Waitus(5);  						// warte 5us
	
	PORTB |= (1 << PB0);				//PORTB.0 = 1
	Page = 0;
}

void Glcd_init (void){
	  PORTB &= ~( 1 << PB0); 			//A = 0 Portb.0 
	  Spiout (0b10001100);				// Kontrast einstellen
	  Spiout (0b10100010);				// LCD Bias 1/6
	  Spiout (0b10100001);				// gespiegelte Anzeige
	  Spiout (0b00101111);				// internen Spannungswandler aktivieren
	  Spiout (0b10101111);				// display an 
	  Spiout (0b01000100);				// start Dispay line
	  D_byte = 0;
	  Waitms (50);
	  X_byte = 1;
	  PORTB |= ( 1 << PB0); 				//A = 1
}

void Edo_write ( unsigned int Collumn , unsigned int Row , unsigned char Edobyte ){
    unsigned char Collhigh_w;
    unsigned char Colllow_w;
    unsigned char Rowhigh_w; 	// = High(row)
    unsigned char Rowlow_w; 	// = Low(row)

	Collhigh_w = (uint8_t)(Collumn >> 8);
	Colllow_w = (uint8_t)(Collumn);
    Rowhigh_w = (uint8_t)(Row >> 8);
	Rowlow_w = (uint8_t)(Row);

	DDRA = 0b11111111;

	if ((Rowhigh_w & 0b00000001)==0b00000001){  // Portd.2 = Rowhigh_w.0
		PORTD |= 0b00000100;
	}
	else {
		PORTD &= 0b11111011;
	}
	if ((Rowhigh_w & 0b00000010)==0b00000010){  // Portd.3 = Rowhigh_w.1
		PORTD |= 0b00001000;
	}
	else {
		PORTD &= 0b11110111;
	}
    PORTC = Rowlow_w;
	

    // RAS und WE nicht gleichzeitig setzen wegen EDO-RAM-Timing
    PORTD &= 0b11011111;							//Ras = 0
    PORTD &= 0b11101111;							//We = 0

	if ((Collhigh_w & 0b00000001)==0b00000001){  // Portd.2 = Collhigh_w.0
		PORTD |= 0b00000100;
	}
	else {
		PORTD &= 0b11111011;
	}
	if ((Collhigh_w & 0b00000010)==0b00000010){  // Portd.3 = Collhigh_w.1
		PORTD |= 0b00001000;
	}
	else {
		PORTD &= 0b11110111;
	}

	PORTC = Colllow_w;

    PORTA = Edobyte;
    PORTD &= 0b10111111; 						// Cas = 0
    PORTD |= 0b00010000; 						// We = 1
    PORTD |= 0b00100000;						// Ras = 1
    PORTD |= 0b01000000;						// Cas = 1
    DDRA = 0b00000000;
    PORTA = 0;
}

void Edo_clear (void){
	unsigned int x; 
	unsigned int y;
	unsigned char z;
	z=0;
	for(x = 0 ; x<1023 ; x++ ){
		for( y=0 ; y<1023 ; y++){
			Edo_write(x,y,z);			
		}
	}
}


unsigned char Edo_read (unsigned int Collumn , unsigned int Row){
	DDRA = 0b00000000;
	PORTD |= 0b00010000;							//We = 1
    unsigned char Collhigh_w;
    unsigned char Colllow_w;
    unsigned char Rowhigh_w; // = High(row)
    unsigned char Rowlow_w; // = Low(row)

	Collhigh_w = (uint8_t)(Collumn >> 8);
	Colllow_w = (uint8_t)(Collumn);
    Rowhigh_w = (uint8_t)(Row >> 8);
	Rowlow_w = (uint8_t)(Row);

	if ((Rowhigh_w & 0b00000001)==0b00000001){  // Portd.2 = Rowhigh_w.0
		PORTD |= 0b00000100;
	}
	else {
		PORTD &= 0b11111011;
	}
	if ((Rowhigh_w & 0b00000010)==0b00000010){  // Portd.3 = Rowhigh_w.1
		PORTD |= 0b00001000;
	}
	else {
		PORTD &= 0b11110111;
	}
    PORTC = Rowlow_w;

    PORTD &= 0b11011111;							//Ras = 0
	if ((Collhigh_w & 0b00000001)==0b00000001){  // Portd.2 = Collhigh_w.0
		PORTD |= 0b00000100;
	}
	else {
		PORTD &= 0b11111011;
	}
	if ((Collhigh_w & 0b00000010)==0b00000010){  // Portd.3 = Collhigh_w.1
		PORTD |= 0b00001000;
	}
	else {
		PORTD &= 0b11110111;
	}

	PORTC = Colllow_w;

    PORTD &= 0b10111111; 						// Cas = 0
	return PINA;
    PORTD |= 0b00100000;						// Ras = 1
    PORTD |= 0b01000000;						// Cas = 1
    DDRA = 0b00000000;
}

int main(void){ 				// Mainloop

	UBRRL = takt / (8 * baud3) -1;
	UCSRB = (1<<RXEN)|(1<<TXEN)|(1<< RXCIE);
	UCSRC =	 (1 << URSEL)|(1<<UCSZ1)|(1<<UCSZ0);
	

	// SPI initialisieren
	DDRB=(1 << DDB7) | (1 << DDB5) | (1 << DDB4) | (1 << DDB3)| (1 << DDB2) | (1 << DDB1) | (1 << DDB0);
	SPCR = (1 << SPE) | (1 << MSTR) | (1 << SPR0) | (1 << CPHA); 		// SPI ein, MSB first, Clock / 4
	
	PORTB |= (1 << PB0) | (1 << PB2); 		// A = 1  Portb.0 , Cs1 = 1  Portb.2
	PORTB &= ~((1 << PB1) | (1 << PB3));	// Cs2 = 0  Portb.3 , Res = 0  Portb.1
	
	Wait(1); 								// warte 1 Sekunde
	PORTB |= ( 1 << PB1 ); 					//A = 0    Portb.0
	PORTB &= ~( 1 << PB0 ); 				//	Res = 1  Portb.1
	
	
	Edo_clear();
	sei();
	
	Glcd_init();							// GLCD initialisieren
	Glcd_clear();							// Anzeige lschen
	
	Cam_sync();
	Cam_reset();
	// Platzhalter fr Init2 Funktion
	Cam_config();
	Cam_baudrate();

	UBRRL = takt / (8 * baud) -1;

	Cam_packsize();

	// ##################################
	
	
	
	while(1){
	}

	// ##################################

} 					// Mainloop Ende


//ISR (SIG_UART_RECV){
//	Flag=1;		
//}
